Subject: bug#12492: Acknowledgement (24.2.50; Open vc-dir buffer easier and faster)

From: Juri Linkov <[email-masked]>
Date: Fri, 06 Mar 2020 01:59:49 +0200

>> Only getting project file names should be synchronous and blocking,
>> everything else (including grepping) could be asynchronous.
>
> The API indeed allows it, but there are no good UIs with that support that
> we can use. But you're welcome to fix/improve/write one.

rgrep/vc-git-grep provides good UI.

>> The result is almost instantaneous: 1 sec on Emacs repo.
>
> I don't understand how that's possible: it's much longer than that on my
> machine, and I have a fast laptop manufactured last year, with NVMe and 
> stuff.

The speed depends on the number of files with matches.
It's quick when matches are in a few files.

>>> Not to mention the unfortunate side-effect of having to visit 4000 buffers.
>> It visits only matched buffers.
>
> No. It looks through all project files and calls 'find-file' on each of
> them. Which is obviously inevitable since multi-occur only accepts a 
> list of buffers, not files.

No, it doesn't call 'find-file' on each file, noccur-project
calls 'find-file' only on files with matches found by grep.

> Anyway, if you want to continue this chat, could you file a relevant bug,
> or post to emacs-devel?
>
> All of this is certainly not about vc-dir anymore.

Regarding vc-dir, I see no better name than 'vc-dir-default'
meaning that it uses root-dir by default.